/*
 * Copyright (c) 2015-2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __ATLAS7_IPC_H__
#define __ATLAS7_IPC_H__

#define _IPC_REG_BASE 0x13240000

/* Registers of Interrupt Trigger&Clear */
#define A7DA_IPC_TRGT1_INIT0_1		(_IPC_REG_BASE + 0x0000)
#define A7DA_IPC_TRGT1_INIT0_2		(_IPC_REG_BASE + 0x0004)
#define A7DA_IPC_TRGT2_INIT0_1		(_IPC_REG_BASE + 0x0008)
#define A7DA_IPC_TRGT2_INIT0_2		(_IPC_REG_BASE + 0x000C)
#define A7DA_IPC_TRGT3_INIT0_1		(_IPC_REG_BASE + 0x0010)
#define A7DA_IPC_TRGT3_INIT0_2		(_IPC_REG_BASE + 0x0014)
#define A7DA_IPC_TRGT0_INIT1_1		(_IPC_REG_BASE + 0x0100)
#define A7DA_IPC_TRGT0_INIT1_2		(_IPC_REG_BASE + 0x0104)
#define A7DA_IPC_TRGT2_INIT1_1		(_IPC_REG_BASE + 0x0108)
#define A7DA_IPC_TRGT2_INIT1_2		(_IPC_REG_BASE + 0x010C)
#define A7DA_IPC_TRGT3_INIT1_1		(_IPC_REG_BASE + 0x0110)
#define A7DA_IPC_TRGT3_INIT1_2		(_IPC_REG_BASE + 0x0114)
#define A7DA_IPC_TRGT0_INIT2_1		(_IPC_REG_BASE + 0x0200)
#define A7DA_IPC_TRGT0_INIT2_2		(_IPC_REG_BASE + 0x0204)
#define A7DA_IPC_TRGT1_INIT2_1		(_IPC_REG_BASE + 0x0208)
#define A7DA_IPC_TRGT1_INIT2_2		(_IPC_REG_BASE + 0x020C)
#define A7DA_IPC_TRGT3_INIT2_1		(_IPC_REG_BASE + 0x0210)
#define A7DA_IPC_TRGT3_INIT2_2		(_IPC_REG_BASE + 0x0214)
#define A7DA_IPC_TRGT0_INIT3_1		(_IPC_REG_BASE + 0x0300)
#define A7DA_IPC_TRGT0_INIT3_2		(_IPC_REG_BASE + 0x0304)
#define A7DA_IPC_TRGT1_INIT3_1		(_IPC_REG_BASE + 0x0308)
#define A7DA_IPC_TRGT1_INIT3_2		(_IPC_REG_BASE + 0x030C)
#define A7DA_IPC_TRGT2_INIT3_1		(_IPC_REG_BASE + 0x0310)
#define A7DA_IPC_TRGT2_INIT3_2		(_IPC_REG_BASE + 0x0314)

/* Registers of Hardware Spinlock */
#define A7DA_IPC_SPINLOCK_RD_DEBUG	(_IPC_REG_BASE + 0x0400)
#define A7DA_IPC_TESTANDSET_0		(_IPC_REG_BASE + 0x0404)
#define A7DA_IPC_TESTANDSET_1		(_IPC_REG_BASE + 0x0408)
#define A7DA_IPC_TESTANDSET_2		(_IPC_REG_BASE + 0x040C)
#define A7DA_IPC_TESTANDSET_3		(_IPC_REG_BASE + 0x0410)
#define A7DA_IPC_TESTANDSET_4		(_IPC_REG_BASE + 0x0414)
#define A7DA_IPC_TESTANDSET_5		(_IPC_REG_BASE + 0x0418)
#define A7DA_IPC_TESTANDSET_6		(_IPC_REG_BASE + 0x041C)
#define A7DA_IPC_TESTANDSET_7		(_IPC_REG_BASE + 0x0420)
#define A7DA_IPC_TESTANDSET_8		(_IPC_REG_BASE + 0x0424)
#define A7DA_IPC_TESTANDSET_9		(_IPC_REG_BASE + 0x0428)
#define A7DA_IPC_TESTANDSET_10		(_IPC_REG_BASE + 0x042C)
#define A7DA_IPC_TESTANDSET_11		(_IPC_REG_BASE + 0x0430)
#define A7DA_IPC_TESTANDSET_12		(_IPC_REG_BASE + 0x0434)
#define A7DA_IPC_TESTANDSET_13		(_IPC_REG_BASE + 0x0438)
#define A7DA_IPC_TESTANDSET_14		(_IPC_REG_BASE + 0x043C)
#define A7DA_IPC_TESTANDSET_15		(_IPC_REG_BASE + 0x0440)
#define A7DA_IPC_TESTANDSET_16		(_IPC_REG_BASE + 0x0444)
#define A7DA_IPC_TESTANDSET_17		(_IPC_REG_BASE + 0x0448)
#define A7DA_IPC_TESTANDSET_18		(_IPC_REG_BASE + 0x044C)
#define A7DA_IPC_TESTANDSET_19		(_IPC_REG_BASE + 0x0450)
#define A7DA_IPC_TESTANDSET_20		(_IPC_REG_BASE + 0x0454)
#define A7DA_IPC_TESTANDSET_21		(_IPC_REG_BASE + 0x0458)
#define A7DA_IPC_TESTANDSET_22		(_IPC_REG_BASE + 0x045C)
#define A7DA_IPC_TESTANDSET_23		(_IPC_REG_BASE + 0x0460)
#define A7DA_IPC_TESTANDSET_24		(_IPC_REG_BASE + 0x0464)
#define A7DA_IPC_TESTANDSET_25		(_IPC_REG_BASE + 0x0468)
#define A7DA_IPC_TESTANDSET_26		(_IPC_REG_BASE + 0x046C)
#define A7DA_IPC_TESTANDSET_27		(_IPC_REG_BASE + 0x0470)
#define A7DA_IPC_TESTANDSET_28		(_IPC_REG_BASE + 0x0474)
#define A7DA_IPC_TESTANDSET_29		(_IPC_REG_BASE + 0x0478)

#define A7DA_IPC_TESTANDSET(x)		(A7DA_IPC_TESTANDSET_0 + 0x4 * (x))

#endif /* __ATLAS7_IPC_H__ */
